=== src/rp2_common/hardware_riscv/CMakeLists.txt ===
pico_simple_hardware_headers_only_target(riscv)
